package com.dsic.gj_erp.controller.jcsj;


import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.EmSbwxjh;
import com.dsic.gj_erp.bean.request.EmSbwxjhBean;
import com.dsic.gj_erp.service.jcsj.EmSbwxjhService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@RestController
@RequestMapping("/emSbwxjh")
@Api(tags = "设备维修计划")
public class EmSbwxjhController {
    @Autowired
    EmSbwxjhService emSbwxjhService;

    @ApiOperation(value = "查询")
    @PostMapping(value = "/getList")
    public ResultBean getList(@RequestBody EmSbwxjhBean emSbwxjhBean) {
        List<EmSbwxjh> emSbjbbs= emSbwxjhService.getList(emSbwxjhBean);
        return new ResultBean(emSbjbbs);
    }

    @ApiOperation(value = "批量新增")
    @AuthFunction()
    @PostMapping(value = "/save")
    public ResultBean save(@RequestBody List<EmSbwxjh> emSbwxjhs, HttpServletRequest request) {
        emSbwxjhService.save(emSbwxjhs,request);

        return new ResultBean();
    }

    @ApiOperation(value = "批量修改")
    @PostMapping(value = "/update")
    public ResultBean update(@RequestBody List<EmSbwxjh> emSbwxjhs) {
        emSbwxjhService.update(emSbwxjhs);

        return new ResultBean();
    }

    @ApiOperation(value = "批量删除")
    @PostMapping(value = "/delete")
    public ResultBean delete(@RequestBody List<EmSbwxjh> emSbwxjhs) {
        emSbwxjhService.delete(emSbwxjhs);

        return new ResultBean();
    }
}

