package com.dsic.gj_erp.controller.zyjh;


import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.zyjh.DmYppyz;
import com.dsic.gj_erp.controller.zyjh.dto.YppDto;
import com.dsic.gj_erp.service.zyjh.DmYppyzService;
import lombok.AllArgsConstructor;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@RestController
@RequestMapping("yppyz")
@AllArgsConstructor
public class DmYppyzController {

    private final DmYppyzService service;

    @PostMapping("wbfList")
    public ResultBean<?> wbfList(@RequestBody DmYppyz entity){
        List<YppDto> list = service.wbfList(entity);
        return new ResultBean<>(list);
    }

    @PostMapping("submit")
    @Transactional(rollbackFor = Exception.class)
    public ResultBean<?> list(@RequestBody Map<String,List<DmYppyz>> map){
        if (map.get("add")!=null){
            map.get("add").forEach(service::save);
        }

        if (map.get("edit")!=null){
            service.updateBatchById(map.get("edit"));
        }

        if (map.get("remove")!=null){
            List<Integer> remove = map.get("remove").stream().map(DmYppyz::getId).collect(Collectors.toList());
            service.removeByIds(remove);
        }

        return new ResultBean<>();
    }

    @PostMapping("list")
    public ResultBean<?> list(@RequestBody DmYppyz entity){
        if (entity.getStatus()==DmYppyz.StatusEnum.全部){
            entity.setStatus(null);
        }
        List<DmYppyz> list = service.list(Wrappers.<DmYppyz>lambdaQuery()
                .eq(StrUtil.isNotEmpty(entity.getDcCh()), DmYppyz::getDcCh, entity.getDcCh())
                .eq(StrUtil.isNotEmpty(entity.getDcPl()), DmYppyz::getDcPl, entity.getDcPl())
                .eq(ObjUtil.isNotEmpty(entity.getStatus()),DmYppyz::getStatus, entity.getStatus())
        );
        return new ResultBean<>(list);
    }
}
